#include <algorithm>
#include <list>
#include "basis.h"

#include "gcc_version.h"
#if GCC_VERSION>=3002
#include <ext/algorithm>
#include <ext/memory>
#endif

using namespace std;

void Tpolin::print(ostream &os) const {
	os<<tag()<<'='<<polin();
}

bool BasisBase::isStable() const {
	for (const_iterator i=begin();i!=end();++i) {
		if (i->lt().edegree()>0) return false;
	}
	return true;
}

void BasisBase::print(ostream &os) const {
	copy(begin(),end(),ostream_iterator<Tpolin>(os,"\n"));
}

void Basis::Lterms::div_iterator::seekDivisor() {
	bool found=false;
	while (m_base!=m_cont.end() && !found) {
  	const Eterm &et=m_base->first;
		if ( m_et.edegree()<et.edegree() ) {
			m_base=m_cont.end();
		}
		else {
    	int n=et.size();
  		found=true;
    	for(int i=0;i<n;++i) {
    		if (m_et[i]<et[i]) {
    			Eterm pattern(et.context());
  				pattern.setEdegree(et.edegree());
    			__gnu_cxx::copy_n(et.begin(),i,pattern.begin());
    			fill_n(pattern.begin()+i,n-i,INT_MAX);
    			m_base=m_cont.lower_bound(pattern);
  				found=false;
  				break;
    		}
    	}
		}
	}
}

void Basis::reDivs() {
	m_lterms.clear();
	for(const_iterator i=begin();i!=end();++i) m_lterms.insert(i);
}

SetOfEterms Basis::supp() const {
	SetOfEterms result;
	for(const_iterator i=begin();i!=end();++i) result.unite(i->polin().supp());
	return result;
}

