#if defined (USG) || defined (__SVR4) || defined (_UNICOS) || defined (__hpux) // strange way
#include <time.h>

int cpu_time() {
  if (CLOCKS_PER_SEC < 100000)
    return clock () * 1000 / CLOCKS_PER_SEC;
  return clock () / (CLOCKS_PER_SEC / 1000);
}

#elif defined(_WIN32) // win way

#include <windows.h>
#include <psapi.h>

extern "C" int cpu_time() {
  int nRet=-1;
  HANDLE hProcess;
  FILETIME ftCreate, ftExit, ftKernel, ftUser;
	hProcess = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, FALSE, GetCurrentProcessId());
  if (GetProcessTimes(hProcess, &ftCreate, &ftExit, &ftKernel, &ftUser)) {
    const unsigned long ulMax=0xFFFFFFFF;
    nRet = ftUser.dwHighDateTime*(ulMax/10000)+
              (ftUser.dwLowDateTime+ftUser.dwHighDateTime*(ulMax%10000))/10000;
  }
	CloseHandle( hProcess );
	return nRet;
}

#else // unix way

#include <sys/types.h>
#include <sys/time.h>
#include <sys/resource.h>

extern "C" int cpu_time() {
  struct rusage rus;

  getrusage (0, &rus);
  return rus.ru_utime.tv_sec * 1000 + rus.ru_utime.tv_usec / 1000;
}

#endif
