#if !defined(__EBOUND_H__)
#define __EBOUND_H__

#include "coeff.h"

struct Ebound {
	Ebound(const Coeff &eps, int eb):m_epsilon(eps),m_threshold(eps2thres(eps,eb)),m_bound(eb) {}
	Ebound(const Coeff &eps,Scheme scm):m_epsilon(eps),m_scheme(scm) {}
	Ebound(const Ebound &aeq):m_epsilon(aeq.m_epsilon),m_scheme(aeq.m_scheme) {}

	Ebound &operator=(const Ebound &aeq) {
		m_epsilon=aeq.epsilon();
		m_scheme=aeq.scheme();
		return *this;
	}

	const Coeff &epsilon() const {return m_epsilon;}
	void epsilon(const Coeff &eps) {m_epsilon=eps;m_threshold=eps2thres(eps,m_bound);}
	int bound() const {return m_bound;}
	const Coeff &threshold() const {return m_threshold;}

	Scheme scheme() const {return m_scheme;}
	void scheme(const Scheme scm) {m_scheme=scm;}

	void print (std::ostream &os) const;

private:

	Coeff m_threshold;
	int m_bound;
	
};

inline std::ostream &operator<<(std::ostream &os,const Ebound &ae) {
	ae.print(os);
	return os;
}

#endif //__EBOUND_H__
