#include "reduction.h"
#include "cset.h"

#include "gbasis.h"

void Gbasis::operator()(Basis &basis) {
	Stat stat;
	Reduction reduce(report(),stat);
	reduce.mutual(basis);
	Cset cset(report(),stat);
	cset.add(basis);
	while (!cset.empty()) {
		Basis cpols;
		int ctype=cset.deliver(cpols);
		if (ctype==2)
			reduce.spairs(cpols,basis);
		else
			reduce(cpols,basis);
		basis.insert(cpols.begin(),cpols.end());
		cset.add(cpols);
	}
	cset.clear();
	reduce.mutualG(basis);
	rs()<<stat;
}

