#if !defined(__MULTMATR_H__)
#define __MULTMATR_H__

#include <vector>
#include "borderbasis.h"
#include "printSequence.h"

class MultMatr: public std::vector<std::vector<Coeff> > {

	typedef std::vector<Coeff> Row;
	typedef std::vector<std::vector<Coeff> > Inherited;

	SetOfTerms m_ns;
	std::string m_var;	

public:
	MultMatr(const SetOfTerms &ns);
	void clear();
	void operator()(const BorderBasis &bb,int v);
	void print(std::ostream &os) const;
	void printMaple(std::ostream &os) const;

	MultMatr &comb(const MultMatr &mm, const Coeff &c);
private:

	static void printMapleRow(std::ostream &os, const_iterator row);

};

inline std::ostream &operator<<(std::ostream &os, const MultMatr &mm) {
	mm.print(os);
	return os;
}

template<class Iter>
inline std::ostream &printRow(std::ostream &os, Iter first, Iter last) {
	PrintSequence<Iter> ps(",","(",")");
	return ps(os,first,last);
}

template<class Iter>
inline std::ostream &printCol(std::ostream &os, Iter first, Iter last) {
	PrintSequence<Iter> ps(",","[","]");
	return ps(os,first,last);
}

#endif //__MULTMATR_H__

