#if !defined(PRINTSEQUENCE_H)
#define PRINTSEQUENCE_H

#include <ostream>
#include <iterator>
#include <algorithm>

template<class Iter,class value_type = typename std::iterator_traits<Iter>::value_type>
struct PrintSequence {
//  typedef typename std::iterator_traits<Iter>::value_type value_type;
  PrintSequence(const char *inf=",",const char *pref="",const char *post="\n"):infix(inf),prefix(pref),postfix(post) {}
  std::ostream &operator()(std::ostream &os,Iter first,Iter last) const;
private:
  const char *infix;
  const char *prefix;
  const char *postfix;
};

template<class Iter,class value_type>
std::ostream &PrintSequence<Iter,value_type>::operator()(std::ostream &os, Iter first,Iter last) const {
  os<<prefix;
  if (first==last)
	os<<"<empty>";
  else {
	std::copy(first,--last,std::ostream_iterator<value_type>(os,infix));
	const value_type &last_val=*last;
	os<<last_val;
  }
  os<<postfix;
  return os;
}

#endif //PRINTSEQUENCE_H
