#if !defined(__SYMBRED_H__)
#define __SYMBRED_H__

#include "basis.h"
#include "setofeterms.h"
#include "report.h"

class SymbRed: public Report, public Stat {

	SetOfEterms m_done;
	SetOfEterms m_red;
	SetOfEterms m_keep;
	Pcounter counter;

	typedef Basis::const_iterator basis_iterator;

	int symbRed(Basis &pols, const Basis &basis, const Basis &simp, bool self);

public:

	SymbRed(const Report &r, const Stat &s):Report(r),Stat(s),counter('R') {
		stat().add("sr","symbolic reductions");
	}
	int operator()(Basis &pols, const Basis &basis, const Basis &simp);
	int spairs(Basis &pols, const Basis &basis, const Basis &simp);

	int mutual(Basis &pols);
	void clear();

	const SetOfEterms &red() const {return m_red;}
	const SetOfEterms &keep() const {return m_keep;}
};

#endif //__SYMBRED_H__
