
#include <iterator>
#include <algorithm>
#include "checks.h"
#include "text.h"

using namespace std;

void Text::clear() {
	m_data.clear();
	reset();
}

void Text::load(std::istream &is) {
	PRECONDITION(is);
	clear();
	while (!is.eof()) {
		char s[1024];
		is.getline(s,sizeof(s));
		m_data.push_back(string(s));
	}
	reset();
}

void Text::reset()  {
	lin=m_data.begin();
	linum=0;
	if (!m_data.empty()) col=lin->begin();
}

const string &Text::line(int k) const {
	static string nilStr;
	Data::const_iterator i=m_data.begin();
	while (k>0 && i!=m_data.end()) {--k;++i;}
	return (i==m_data.end())?nilStr:*i;
}

void Text::dump(std::ostream &os) const {
	std::copy(m_data.begin(),m_data.end(),std::ostream_iterator<string>(os,"\n"));
}

void Text::next() {
	PRECONDITION(!eot());
	if ( col==lin->end() ) {
		++lin;++linum;
		if (!eot()) col=lin->begin();
	}
	else ++col;
}

void Text::pred() {
	PRECONDITION(!bot());
	if ( eot() || col==lin->begin() ) {
		--lin;--linum;
		col=lin->end();
	}
	else --col;
}

void Text::getpos(int &l,int &c) {
	l=linum;
	c=(eot())?0:distance(lin->begin(),col);
}

char Text::getc() {
	PRECONDITION(!eot());
	char c = ( col==lin->end() ) ? '\n':*col;
	next();
	return c;
}
