#if !defined __TEXT_H__
#define __TEXT_H__

#include <iostream>
#include <list>

class Text {

	typedef std::list<std::string> Data;
	Data m_data;
	int linum;
	Data::const_iterator lin;
	std::string::const_iterator col;

	void next();
	void pred();
public:

	Text():linum(0) {lin=m_data.end();}
	Text(std::istream &is) {load(is);}
	void load(std::istream &is);
	void dump(std::ostream &os) const;
	void reset();
	void clear();

	const std::string &line(int k) const;

	bool empty() const {return m_data.empty();}
	bool eot() const {
		return lin==m_data.end();
	}
	bool bot() const {
		return empty() || ( lin==m_data.begin() && col==lin->begin() );
	}

	void getpos(int &,int &);

	char getc();
	void ungetc() {pred();}
};

#endif //__TEXT_H__
